'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Transaction = undefined;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }(); /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       Generic Transaction forming, signing, and verifying here.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       Need to place any network-specific transaction definitions elsewhere.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     */


exports.hashifyObject = hashifyObject;
exports.stringifyObject = stringifyObject;

var _lodash = require('lodash');

var _ = _interopRequireWildcard(_lodash);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var sha256 = require("crypto-js/sha256");

/*

*/

var Transaction = exports.Transaction = function () {
  function Transaction(tx) {
    _classCallCheck(this, Transaction);

    this.fqdn = tx.fqdn;
    this.network_id = tx.network_id;
    this.type = tx.type;
    this.signature = tx.signature;
    this.fromVk = tx.fromVk;
    if (typeof tx.data === 'string') {
      this.data = JSON.parse(tx.data);
    } else {
      this.data = tx.data;
    }
  }

  _createClass(Transaction, [{
    key: 'hash',
    value: function hash() {
      // Should return a Hex String
      /*
        This is generating the hash by hashing the key/value pairs from the data
        sorted by the key in alphanumerical order, separated by a delimiter.
      */
      var delimiter = '|';
      var source = {
        network_id: this.network_id,
        type: this.type,
        fqdn: this.fqdn,
        data: this.data
      };
      return hashifyObject(source, delimiter);
    }
  }, {
    key: 'sign',
    value: function sign(credential) {
      // Should return a Hex String
      if (this.fromVk !== credential.vkToHex()) return false;
      var signature = credential.signUTF8(this.hash())[0];
      this.signature = signature;
      return signature;
    }
  }, {
    key: 'verify',
    value: function verify(StateView) {
      // Should return an array with [Result (Boolean), Error Code]
      // Needs to depend on TX type and have some way of registering TX types.
      return '';
    }
  }, {
    key: 'apply',


    // Stub
    value: function apply(StateView) {
      // Low on list of priorities to implement for initial clientside
      // Should return an array with [Result (Boolean), New StateView, Error Code]
      return '';
    }
  }]);

  return Transaction;
}();

function hashifyObject(obj, delimiter) {
  var hashString = stringifyObject(obj, delimiter);
  hashString = hashString.substring(0, hashString.length - 1);
  var hash = sha256(hashString).toString();
  return hash;
}

function stringifyObject(obj, delimiter) {
  var hashString = '';
  if (delimiter === undefined) delimiter = '|';
  if ((typeof obj === 'undefined' ? 'undefined' : _typeof(obj)) === 'object') {
    _.forEach(_.sortBy(_.keys(obj), function (o) {
      return o;
    }), function (key) {
      if (!Array.isArray(obj)) {
        hashString += new Buffer(key).toString('hex');
        hashString += delimiter;
      }
      hashString += stringifyObject(obj[key], delimiter);
    });
  } else if (typeof obj === 'number') {
    hashString += new Buffer(obj.toString(10)).toString('hex');
    hashString += delimiter;
  } else {
    hashString += new Buffer(obj).toString('hex');
    hashString += delimiter;
  }

  return hashString;
}